searchNodes=[{"doc":"Unified access to tabular data. Various data structures have a tabular representation, however to access this representation, manual conversion is required. On top of that, tabular access itself has two variants, a row-based one and a column-based one, each useful under different circumstances. The Table package provides a thin layer that unifies access to tabular data in different formats. Protocol The unified access is enabled for structs implementing the Table.Reader protocol. Note that a struct may be representable as tabular data only in some cases, so the protocol implementation may be lax. Consequently, functions in this module will raise when given non-tabular data. By default the protocol is implemented for lists and maps of certain shape. # List of matching key-value lists data = [ [ { &quot;id&quot; , 1 } , { &quot;name&quot; , &quot;Sherlock&quot; } ] , [ { &quot;id&quot; , 2 } , { &quot;name&quot; , &quot;John&quot; } ] ] # List of matching maps data = [ %{ &quot;id&quot; =&gt; 1 , &quot;name&quot; =&gt; &quot;Sherlock&quot; } , %{ &quot;id&quot; =&gt; 2 , &quot;name&quot; =&gt; &quot;John&quot; } ] # List of column tuples data = [ { &quot;id&quot; , 1 .. 2 } , { &quot;name&quot; , [ &quot;Sherlock&quot; , &quot;John&quot; ] } ] # Map with column values data = %{ &quot;id&quot; =&gt; [ 1 , 2 ] , &quot;name&quot; =&gt; [ &quot;Sherlock&quot; , &quot;John&quot; ] }","ref":"Table.html","title":"Table","type":"module"},{"doc":"Accesses tabular data as individual columns. Returns a map with enumerables as values. Options :only - specifies a subset of columns to include in the result Examples iex&gt; data = [ %{ id : 1 , name : &quot;Sherlock&quot; } , %{ id : 2 , name : &quot;John&quot; } , %{ id : 3 , name : &quot;Mycroft&quot; } ] iex&gt; columns = Table . to_columns ( data ) iex&gt; Enum . to_list ( columns . id ) [ 1 , 2 , 3 ] iex&gt; Enum . to_list ( columns . name ) [ &quot;Sherlock&quot; , &quot;John&quot; , &quot;Mycroft&quot; ]","ref":"Table.html#to_columns/2","title":"Table.to_columns/2","type":"function"},{"doc":"","ref":"Table.html#to_columns_with_info/2","title":"Table.to_columns_with_info/2","type":"function"},{"doc":"Accesses tabular data as a sequence of rows. Returns an enumerable that emits each row as a map. Options :only - specifies a subset of columns to include in the result Examples iex&gt; data = %{ id : [ 1 , 2 , 3 ] , name : [ &quot;Sherlock&quot; , &quot;John&quot; , &quot;Mycroft&quot; ] } iex&gt; data |&gt; Table . to_rows ( ) |&gt; Enum . to_list ( ) [ %{ id : 1 , name : &quot;Sherlock&quot; } , %{ id : 2 , name : &quot;John&quot; } , %{ id : 3 , name : &quot;Mycroft&quot; } ] iex&gt; data = [ [ id : 1 , name : &quot;Sherlock&quot; ] , [ id : 2 , name : &quot;John&quot; ] , [ id : 3 , name : &quot;Mycroft&quot; ] ] iex&gt; data |&gt; Table . to_rows ( ) |&gt; Enum . to_list ( ) [ %{ id : 1 , name : &quot;Sherlock&quot; } , %{ id : 2 , name : &quot;John&quot; } , %{ id : 3 , name : &quot;Mycroft&quot; } ]","ref":"Table.html#to_rows/2","title":"Table.to_rows/2","type":"function"},{"doc":"","ref":"Table.html#to_rows_with_info/2","title":"Table.to_rows_with_info/2","type":"function"},{"doc":"","ref":"Table.html#t:column/0","title":"Table.column/0","type":"type"},{"doc":"","ref":"Table.html#t:tabular/0","title":"Table.tabular/0","type":"type"},{"doc":"A protocol to read tabular data.","ref":"Table.Reader.html","title":"Table.Reader","type":"protocol"},{"doc":"Returns information on how to traverse the given tabular data. There are generally two distinct ways of traversing tabular data, that is, a row-based one and a column-based one. Depending on the underlying data representation, one of them is more natural and more efficient. The init/1 return value describes either of the two traversal types, see row_reader/0 and column_reader/0 respectively. Some structs may be tabular only in a subset of cases, therefore :none may be returned to indicate that there is no valid data to read. The init/1 function should not initiate any form of traversal or open existing resources. If any setup is necessary, it should be performed when the underlying row or column enumerables are traversed.","ref":"Table.Reader.html#init/1","title":"Table.Reader.init/1","type":"function"},{"doc":"Describes column-based traversal. The enumerable should yield columns, where each column is a series of values. The columns should have the same order as columns in the metadata.","ref":"Table.Reader.html#t:column_reader/0","title":"Table.Reader.column_reader/0","type":"type"},{"doc":"Table metadata. User-specific metadata can be added in the form of namespaced tuples as keys. The first element is the namespace key, typically an atom, and the second is any term. The value can also be anything.","ref":"Table.Reader.html#t:metadata/0","title":"Table.Reader.metadata/0","type":"type"},{"doc":"Describes row-based traversal. The enumerable should yield rows, where each row is a series of values. The values should follow the order of columns in the metadata.","ref":"Table.Reader.html#t:row_reader/0","title":"Table.Reader.row_reader/0","type":"type"},{"doc":"","ref":"Table.Reader.html#t:t/0","title":"Table.Reader.t/0","type":"type"}]